SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'construction block types' stamp: 'GuillermoAres 5/20/2012 21:41'!
blueGhost
	
	^Ghost new
	.! !

!PacManTest methodsFor: 'actors' stamp: 'GuillermoAres 5/20/2012 21:18'!
blueberry

	^Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'AresJamardo 5/16/2012 20:14'!
down

	^Down new.! !

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 19:33'!
ghostHouseDoorType

	^GhostHouseDoorBlock new! !

!PacManTest methodsFor: 'movements' stamp: 'AresJamardo 5/16/2012 19:34'!
left

	^Left new! !

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 19:33'!
leftTransporterType

	^LeftTransporterBlock new! !

!PacManTest methodsFor: 'actors' stamp: 'AresJamardo 5/16/2012 19:32'!
pacman

	^Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'AresJamardo 5/16/2012 20:13'!
right

	^Right new! !

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 19:33'!
spaceType

	^SpaceBlock new
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost goingIn: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost goingIn: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost goingIn: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost goingIn: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman goingIn: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman goingIn: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman goingIn: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman goingIn: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry goingIn: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry goingIn: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry goingIn: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry goingIn: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost goingIn: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost goingIn: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost goingIn: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost goingIn: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman goingIn: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman goingIn: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman goingIn: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman goingIn: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry goingIn: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry goingIn: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry goingIn: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry goingIn: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost goingIn: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost goingIn: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost goingIn: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost goingIn: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman goingIn: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman goingIn: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman goingIn: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman goingIn: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry goingIn: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry goingIn: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry goingIn: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry goingIn: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost goingIn: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost goingIn: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman goingIn: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman goingIn: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'GuillermoAres 5/20/2012 22:33'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry goingIn: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry goingIn: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'AresJamardo 5/16/2012 19:34'!
up

	^Up new! !

!PacManTest methodsFor: 'construction block types' stamp: 'AresJamardo 5/16/2012 19:33'!
wallType

	^WallBlock new! !

Object subclass: #Actor
	instanceVariableNames: 'currentPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Actor class
	instanceVariableNames: 'defaultStartPosition'!

Actor class
	instanceVariableNames: 'defaultStartPosition'!

!Actor methodsFor: 'initialization' stamp: 'GuillermoAres 5/20/2012 22:55'!
initialize

	currentPosition := 0@0.! !

!Actor methodsFor: 'movement' stamp: 'AresJamardo 5/16/2012 20:53'!
moveIn: aDirection to: aBlock
	
	self subclassResponsibility.! !

!Actor methodsFor: 'properties' stamp: 'AresJamardo 5/16/2012 19:35'!
position
	
	^currentPosition.! !

Actor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'movement' stamp: 'GuillermoAres 5/20/2012 21:31'!
moveIn: aDirection to: aBlock
	
	^aBlock nextPositionForFruit: self goingIn: aDirection.! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'movement' stamp: 'GuillermoAres 5/20/2012 21:43'!
moveIn: aDirection to: aBlock

	^aBlock nextPositionForGhost: self goingIn: aDirection.! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'movement' stamp: 'AresJamardo 5/16/2012 20:53'!
moveIn: aDirection to: aBlock

	^aBlock nextPositionForPacman: self goingIn: aDirection.! !

Object subclass: #Block
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Block methodsFor: 'movement resolution' stamp: 'GuillermoAres 5/20/2012 22:40'!
nextPositionFor: anActor allowedToGoIn: aDirection
"This method serves to reduce the number of methods used to implement the double dispatch technique through introducing inheritance along the class of the argument, as stated in the provided paper"

	^aDirection moveFrom: anActor position.! !

!Block methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:33'!
nextPositionFor: anActor goingIn: aDirection

	^anActor moveIn: aDirection to: self.! !

!Block methodsFor: 'movement resolution' stamp: 'GuillermoAres 5/20/2012 22:41'!
nextPositionForAnActorDeniedToMoveFrom: aPosition.
"This method serves to reduce the number of methods used to implement the double dispatch technique through introducing inheritance along the class of the argument, as stated in the provided paper"

	^aPosition.! !

!Block methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:34'!
nextPositionForFruit: aFruit goingIn: aDirection

	^self subclassResponsibility.! !

!Block methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:35'!
nextPositionForGhost: aGhost goingIn:  aDirection

	^self subclassResponsibility ! !

!Block methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:35'!
nextPositionForPacman: aPacman goingIn:  aDirection

	^self subclassResponsibility ! !

Block subclass: #GhostHouseDoorBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorBlock methodsFor: 'conditional movement decision' stamp: 'GuillermoAres 5/20/2012 22:08'!
nextPositionForFruit: aFruit goingIn: aDirection

	^self nextPositionFor: aFruit allowedToGoIn: aDirection.! !

!GhostHouseDoorBlock methodsFor: 'conditional movement decision' stamp: 'GuillermoAres 5/20/2012 22:09'!
nextPositionForGhost: aGhost goingIn:  aDirection

	^self nextPositionFor: aGhost allowedToGoIn: aDirection.! !

!GhostHouseDoorBlock methodsFor: 'conditional movement decision' stamp: 'GuillermoAres 5/20/2012 22:18'!
nextPositionForPacman: aPacman goingIn:  aDirection

	^self nextPositionForAnActorDeniedToMoveFrom: aPacman position.! !

Block subclass: #LeftTransporterBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterBlock methodsFor: 'conditional movement decision' stamp: 'GuillermoAres 5/20/2012 21:39'!
nextPositionForFruit: aFruit goingIn: aDirection

	^(5@10)! !

!LeftTransporterBlock methodsFor: 'conditional movement decision' stamp: 'GuillermoAres 5/20/2012 22:19'!
nextPositionForGhost: aGhost goingIn:  aDirection

	^self nextPositionForAnActorDeniedToMoveFrom: aGhost position.! !

!LeftTransporterBlock methodsFor: 'conditional movement decision' stamp: 'AresJamardo 5/16/2012 20:45'!
nextPositionForPacman: aPacman goingIn:  aDirection

	^(3@10).! !

Block subclass: #SpaceBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceBlock methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:25'!
nextPositionForFruit: aFruit goingIn: aDirection

	^self nextPositionFor: aFruit  allowedToGoIn: aDirection.! !

!SpaceBlock methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:28'!
nextPositionForGhost: aGhost goingIn:  aDirection

	^self nextPositionFor: aGhost allowedToGoIn: aDirection.! !

!SpaceBlock methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:29'!
nextPositionForPacman: aPacman goingIn:  aDirection

	^self nextPositionFor: aPacman allowedToGoIn: aDirection.! !

Block subclass: #WallBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallBlock methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:30'!
nextPositionForFruit: aFruit goingIn:  aDirection

	^self nextPositionForAnActorDeniedToMoveFrom: aFruit position.! !

!WallBlock methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:30'!
nextPositionForGhost: aGhost goingIn:  aDirection

	^self nextPositionForAnActorDeniedToMoveFrom: aGhost position.! !

!WallBlock methodsFor: 'movement decision' stamp: 'GuillermoAres 5/20/2012 22:30'!
nextPositionForPacman: aPacman goingIn:  aDirection

	^self nextPositionForAnActorDeniedToMoveFrom: aPacman position.! !

Object subclass: #Direction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Direction methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 19:52'!
moveFrom: aPosition

	self subclassResponsibility.! !

Direction subclass: #Down
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Down methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 20:16'!
moveFrom: aPosition

	^aPosition + (0@(-1)).! !

Direction subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Left methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 19:58'!
moveFrom: aPosition

	^aPosition + ((-1)@0).! !

Direction subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Right methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 19:56'!
moveFrom: aPosition

	^aPosition + (1@0).! !

Direction subclass: #Up
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Up methodsFor: 'movement execution' stamp: 'AresJamardo 5/16/2012 19:57'!
moveFrom: aPosition

	^aPosition + (0@1).! !
